#pragma interface
#ifndef MODULE_H
#define MODULE_H

#define MODULE_API_VERSION	15
#define MODULE_SYMBOL_VERSION "module_api_version"
#define MODULE_DEFINE_VERSION(name) int module_api_version_##name=MODULE_API_VERSION


#ifndef MISC_H
	#include <misc.h>
#endif

class DIALOG;
class M_DIALOG;
class USERS;
class GROUPS;

#define LNCF_NOT_APPLICABLE	-1000


class LINUXCONF_MODULE: public ARRAY_OBJ{
	char *name;
public:
	/*~PROTOBEG~ LINUXCONF_MODULE */
public:
	LINUXCONF_MODULE (const char *_name);
	virtual int dohtml (const char *);
	virtual int domenu (MENU_CONTEXT, const char *);
	virtual int domenu (const char *, const char *);
	virtual int execmain (int , char *[]);
	virtual int fixperm (bool, bool);
	const char *getname (void);
	virtual int message (const char *,
		 int ,
		 const char *[]);
	virtual int probe (int , int , bool);
	virtual void setmenu (DIALOG&dia,
		 MENU_CONTEXT ctx);
	virtual void setmenu (DIALOG&dia,
		 const char *menuid);
	virtual void setmenu (M_DIALOG&, MENU_CONTEXT);
	virtual void setmenu (M_DIALOG&, const char *);
	void setname (const char *_name);
	virtual void usage (SSTRINGS&);
	~LINUXCONF_MODULE (void);
	/*~PROTOEND~ LINUXCONF_MODULE */
};

#endif

